<template>
  <div class="product-form">
    <section class="section">
      <b-field label="Descrição">
        <b-input v-model="product.description"></b-input>
      </b-field>
      <b-field label="Valor">
        <b-input v-model="product.price"></b-input>
      </b-field>
       
      <the-form-buttons v-on:save="save" v-on:cancel="cancel"></the-form-buttons>
    </section>
  </div>
</template>

<script>
import Cleave from 'cleave.js'
import TheFormButtons from '@/components/TheFormButtons'


const cleave = {
  name: 'cleave',
  bind(el, binding) {
      const input = el.querySelector('input')
      input._vCleave = new Cleave(input, binding.value)
  },
  unbind(el) {
      const input = el.querySelector('input')
      input._vCleave.destroy()
  }
}

export default {
  name: 'ProductForm',
  directives: { cleave },
  props: {
    product: Object,
    isEditing: Boolean 
  },
  data: function ()  {
    return {
      masks: {
        numeral: {
          numeral: true,
          numeralThousandsGroupStyle: 'thousand',
          prefix: 'R$ '
        },
        price: {
          delimiters: ['.', '.', ','],
          blocks: [3,3,2],
          numericOnly: true
        },
        custom: {
          delimiters: ['.', '.', '-'],
          blocks: [3, 3, 3, 2],
          numericOnly: true
        }
      }
    }
  },
  created () {},
  components: {
    'the-form-buttons': TheFormButtons
  },
  methods: {
    save () {
      var payload = {
        csrftoken: this.$cookies.get('csrftoken'),
        description: this.product.description,
        price: this.product.price
      }
      if (this.isEditing) {
        payload.id = this.$route.params.pk
        this.$store.dispatch('updateProduct', payload)
      } else {
        this.$store.dispatch('createProduct', payload)
      }
    },
    cancel () {
      this.$router.go(-1)
    },
    onInput(event) {
      this.rawValue = event.target._vCleave.getRawValue()
      this.value = event.target._vCleave.getFormattedValue()
    }
  },
  computed: {
  }
}
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped lang="scss">
</style>
